#include <allegro.h>
#include "graphics.h"
#include "timer.h"
#include "input.h"
#include "vector.h"
#include "alfont/alfont.h"

BITMAP *back_buffer;

int InitGraphics(void)
{
    set_window_close_button(false);
    set_window_title("CorruptionWare");
     set_color_depth(32);
     if (set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 640, 480, 0, 0) != 0) 
     {
        set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
        allegro_message("Unable to set any graphic mode\n%s\n", allegro_error);
      return 1;
   }
   back_buffer = create_bitmap(SCREEN_W, SCREEN_H);
   
   //Convert everything to 32bpp
   set_color_conversion(COLORCONV_8_TO_32 | COLORCONV_15_TO_32 | COLORCONV_16_TO_32 | COLORCONV_24_TO_32);
   alfont_init();
   return 0;
}

void ReleaseGraphics(void)
{
     destroy_bitmap(back_buffer);
     set_gfx_mode(GFX_TEXT, 0, 0, 0, 0);
     alfont_exit();
}

void ClearScreen(unsigned char red, unsigned char green, unsigned char blue)
{
     clear_to_color(back_buffer, makecol(red, green, blue));
}

void FlipScreen(void)
{
     blit(back_buffer, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
     UpdateInput();
     UpdateTimeInfoAfterScreenFlip();
     UpdateAllVectors();
}

void DrawPixel(int x, int y, unsigned char red, unsigned char green, unsigned char blue)
{
     putpixel(back_buffer, x, y, makecol(red, green, blue));
}
