#ifndef KILL_MARIO_H
#define KILL_MARIO_H
#include "vector.h"
#include "minigame.h"
#include "sound.h"

class KILLMARIO : MINIGAME
{
private:
    SPRITE marioAlive;
    SPRITE marioDead;
    SPRITE platform;   
    SPRITE bowserStill;
    SPRITE bowserFiring;
    SPRITE fireball;
    SPRITE lava;
    SPRITE bridge;
    SPRITE fireballsLeft;
    SOUNDEFFECT fireSound;
    SOUNDEFFECT sizzleSound;
    void DrawBackgroud(void);      
    void DrawFireballsLeft(void);
    
    double difficultySpeed;
     
    VECTOR gameTimer; 
    void DisplayTimer(void);        
            
    struct BOWSER
    {
    };
    BOWSER bowser;
    void DrawBowser(void);  
    
    struct FIREBALL
    {
           bool onscreen;
           bool fired;
           bool missed;
           VECTOR x;
    };
    FIREBALL fire[3];
    void DrawFireball(void);
    
    struct PLATFORM
    {
           int topValue;
           int lowerValue;
           int speed;
           VECTOR y;
    };
    PLATFORM mariosPlatform;
    void DrawPlatform();
    
    struct MARIO
    {
           bool alive;
           double y;  
           VECTOR speed;
    };
    MARIO mario;
    void DrawMario();
public:      
    void LoadArt(void);
    void ReleaseArt(void);
    bool PlayGame(int Difficulty);   //Returns true if you win.
};

#endif
