#include <allegro.h>
#include "sprite.h"
#include "killmario.h"
#include "stopdisk.h"
#include "mgmode.h"
#include "graphics.h"
#include "input.h"
#include "alfont/alfont.h"

void DisplayStage(int stage);
void DisplayResults(int results);

void MiniGameMode(int game)
{
     KILLMARIO killmario;
     STOPDISK  stopdisk;
     int difficulty = 1;
     bool winner = true;
     int progress = 1;
     
     while(winner)
     {
         DisplayStage(progress);         
         if(game == 0)
         {
             killmario.LoadArt();
             winner = killmario.PlayGame(difficulty);
             killmario.ReleaseArt();
         }
         if(game == 1)
         {
             stopdisk.LoadArt();
             winner = stopdisk.PlayGame(difficulty);
             stopdisk.ReleaseArt();
         }
         if(winner)
             progress++;
         
         difficulty++;
         if(difficulty > 255)
            difficulty = 255;
            
     }
     DisplayResults(progress);
     UpdateInput();  
}

void DisplayStage(int stage)
{
     VECTOR timer;
     BITMAP *line;
     ALFONT_FONT *font;
     line = create_bitmap(640, 36);
     timer.SetValue(2);
     timer.SetUPS(-1);
     timer.AddToProcessingList();
     font = alfont_load_font("carbon.ttf");
     alfont_set_font_size(font, 36);
     while(timer.GetValueFloor())
     {
         ClearScreen(0, 0, 0);
         clear_to_color(line, makecol(0, 0, 0));
         alfont_textprintf_centre_aa_ex(line,  font, 320, 0, makecol(255, 255, 255), makecol(0, 0, 0), "STAGE %d", stage);
         blit(line, back_buffer,0, 0, 0, 240 - 18, 640, 36);                  
         FlipScreen();
     }
     
     destroy_bitmap(line);
     timer.RemoveFromProcessingList();
     alfont_destroy_font(font);
}

void DisplayResults(int results)
{
     VECTOR timer;
     BITMAP *line;
     ALFONT_FONT *font;
     line = create_bitmap(640, 36);
     timer.SetValue(2);
     timer.SetUPS(-1);
     timer.AddToProcessingList();
     font = alfont_load_font("carbon.ttf");
     alfont_set_font_size(font, 36);
     
     UpdateInput();
     while(!ButtonADown() && !ButtonEscapeDown())
     {
         ClearScreen(0, 0, 0);
         clear_to_color(line, makecol(0, 0, 0));
         alfont_textprintf_centre_aa_ex(line,  font, 320, 0, makecol(255, 255, 255), makecol(0, 0, 0), "TOTAL STAGES: %d", results);
         blit(line, back_buffer,0, 0, 0, 240 - 18, 640, 36);                  
         FlipScreen();
     }
     
     destroy_bitmap(line);
     timer.RemoveFromProcessingList();
     alfont_destroy_font(font);
}
