#ifndef _SOUND_H
#define _SOUND_H

#include "fmod/fmod.h"

int InitSound(void);
void DestroySound(void);
void LoadSong(char *filename);
void PlaySong(void);
void StopSong(void);
void DestroySong(void);

class SOUNDEFFECT
{
private:
      FSOUND_SAMPLE *sample;
      int channellHandle;
      bool soundOverlapping;
public:
       SOUNDEFFECT();
       ~SOUNDEFFECT();
       void LoadSound(char *filename);
       void PlaySound(void);
       void StopSound(void);
       void DestroySound(void);
       void SetRepeat(bool onoff);
       void AllowSoundOverlapping(bool allow);     //Will it stop the sound before playing it again, or overlap already playing sounds in another channell.          
};

#endif
