#ifndef _VECTOR_H
#define _VECTOR_H

void UpdateAllVectors(void);

class VECTOR
{
private:
        bool inProcessList;     //Is it in the process list to be updated?
        double mainValue;       //Main value.
        double updateValue;     //The rate of change.
        double minValue;        //Lower boundry.     
        double maxValue;        //Upper Boundry.
        bool resetOnBoundry;    //Boundry Behavior.
        double resetValue;
        bool stopOnBoundry;      
public:
       VECTOR();
       ~VECTOR();
       
       //Processing List Functions.
       void AddToProcessingList(void);       //Adds to a list of vectors to update after each frame.
       void RemoveFromProcessingList(void);  //Removes it from that list.
       
       //You don't need to call this (shouldn't call this) if already in the processing list.
       void Update(void);
       
       //Retrieving / Setting the current Value.
       double GetValue(void);           //Gets the value.
       int GetValueFloor(void);              //Gets the value as a floored integer.
       void SetValue(double newValue);  //Sets the current value.
       void SetValue(int newValue);     
       
       //UPS = Updates per second.
       void SetUPS(double updatesPerSecond);   //Sets how much to increase or decrease the main value by per second.
       double GetUPS(void) { return updateValue; }
       
       void SetMax(double max);         //Some vectors will want to stop increasing when they hit Max.
       void SetMin(double min);         //Some vectors will want to stop decreasing when they hit Min.
       void EnableResettingAtBoundry(bool reset); //When it hits a boundry, should it reset?
       void SetResetValue(double ResetValue);  //When they hit Min or Max.
       void EnableStoppingAtBoundry(bool stop); //When it hits a boundry, should it stop.
};

#endif
